<?php 

function solicitar_pix_primepag_ajax(){
    
    global $woocommerce;
    $logger = wc_get_logger();

    $valor_deposito = $_POST["valor_deposito"];
    $talvezAfiliado = $_POST["talvezAfiliado"];

     // Obter o usuário logado
    $current_user = wp_get_current_user();
    $user_email = $current_user->user_email;
    $user_name = $current_user->display_name;

    // Obter o valor do depósito
    $valor_deposito = $_POST["valor_deposito"];

    // Criar o pedido WooCommerce
    $order = wc_create_order(array(
        'customer_id' => $current_user->ID,
    ));

    // Adicionar um item personalizado ao pedido (você pode substituir isso por um produto real se desejar)
    $item_id = $order->add_product(wc_get_product(0), 1, array(
        'name' => 'Depósito via PIX PAGGUE',
        'subtotal' => $valor_deposito,
        'total' => $valor_deposito,
    ));

    // Atualizar o total do pedido
    $order->calculate_totals();

    // Definir o status do pedido como "Aguardando Pagamento"
    $order->update_status('on-hold', 'Pedido criado via solicitar_pix_primepag.'); // 
 
    // Salvar o ID do pedido
    $id_pedido = $order->get_id();

    if($talvezAfiliado):

        add_post_meta( $id_pedido, 'ident_vendedor', $talvezAfiliado, TRUE );
        $logger->info( "RECEBEMOS UM AFILIADO: ".$talvezAfiliado, array( 'source' => 'debug-paggue-afiliado' ) );

    endif;



    // Obtenha todas as configurações do gateway
    $gateway_settings = get_option('woocommerce_primepaggateway_settings');

    $gate_title = $gateway_settings['title'];
    $gate_description = $gateway_settings['description'];
    $gate_enabled = $gateway_settings['enabled'];
    $gate_client_id = $gateway_settings['client_id'];
    $gate_client_secret = $gateway_settings['client_secret'];
    

    $gate_url_de_conexao_api_producao = $gateway_settings['url_de_conexao_api'];

    $primepag_url = $gate_url_de_conexao_api_producao;
    $gate_client_id = $gateway_settings['client_id'];
    $gate_client_secret = $gateway_settings['client_secret'];
    
    
    $token = primepag_token($primepag_url,$gate_client_id,$gate_client_secret);

    

    if($token):

        $status_pagamento = primepag_pix($token,$primepag_url,$id_pedido);

        $logger->info( "STATUS PAGAMENTO EXPRESS: ".$status_pagamento, array( 'source' => 'debug-paggue' ) );
        $logger->info( $status_pagamento, array( 'source' => 'debug-paggue' ) );


        if($status_pagamento["content"]):

            add_post_meta($id_pedido,"primepag_pix","sim",true);
            add_post_meta($id_pedido,"primepag_pix_tid",$status_pagamento["reference_code"],true);
            add_post_meta($id_pedido,"primepag_pix_code",$status_pagamento["content"],true);
            add_post_meta($id_pedido,"primepag_pix_qrcode",$status_pagamento["image_qrcode"],true);

            // ADICIONAR NOTAS AO PEDIDO
            $order->add_order_note( "PIX PAGGUE COPIA E COLA: ".$status_pagamento["content"] );

            // VERIFICAR SE O PAGAMENTO FOI FEITO
            //if (!wp_next_scheduled('executar_consultar_transacao_primepag')):
            //    wp_schedule_single_event(time(), 'executar_consultar_transacao_primepag', array($status_pagamento["reference_code"], $id_pedido));
            //endif;

        else:

                error_log("NÃO CONSEGUIMOS REALIZAR PAGAMENTO COM PIX PAGGUE");
                $logger->info( "STATUS PAGAMENTO ERRO: ".$status_pagamento, array( 'source' => 'debug-paggue' ) );

                return array(
                    'result' => 'error'
                );

                //return false;

        endif;	


    else:

            error_log("NÃO CONSEGUIMOS GERAR O TOKEN PAGGUE");

            return array(
                'result' => 'error'
            );

            //return false;

    endif;


    

    $response = array("status" => 200, 
                      "afiliado" => $talvezAfiliado,  
                      "valor_deposito" => $valor_deposito, 
                      "id_pedido" => $id_pedido, 
                      "image_content" => $status_pagamento["image_qrcode"],
                      "text_content" => $status_pagamento["content"],
                      "id_transacao" => $status_pagamento["reference_code"]);

    wp_send_json( $response );

}

add_action('wp_ajax_solicitar_pix_primepag_ajax', 'solicitar_pix_primepag_ajax');
add_action( 'wp_ajax_nopriv_solicitar_pix_primepag_ajax', 'solicitar_pix_primepag_ajax' );

?>