<?php 

add_action( 'rest_api_init', 'custom_routes_webhook_primepag');

function custom_routes_webhook_primepag(){

    ///wp-json/pluginrifa/v2/infos (exemplo: /wp-json/primepag/notificacoes)
    register_rest_route(
      'paggue', '/notificacoes/', array(
        'methods'       => 'POST',
        'callback'      => 'notificacoes_primepag',
        'show_in_index' => false
      )
    );

    
}

function notificacoes_primepag(WP_REST_Request $request){

	// Obtendo os dados do POST
    $data_received = $request->get_json_params();

    // Log dos dados recebidos
    if (class_exists('WC_Logger')) {
        $logger = new WC_Logger();
        $logger->add('paggue-notificacoes', print_r($data_received, true));
    }

    // Buscar o ID do post com a meta key correspondente
    if($data_received['status']=="1"):
    
		        $order_id = $data_received['external_id'];
		        $order    = wc_get_order($order_id);

            if($order):

  		        $order->update_status('processing');

  		        // Adicionar nota ao pedido informando que o pagamento foi recebido
          		$order_note = "Pagamento recebido via Paggue.io PIX.";
          		$order->add_order_note($order_note);

            endif;

		endif;

    return array('status' => "200");
 
}

?>