<?php 

//add_action('executar_consultar_transacao_primepag', 'consultar_transacao_primepag_agendado', 10, 2);

function consultar_transacao_primepag_agendado($codigo_ref, $order_id) {

    $tentativas = 30; // 6 tentativas a cada 5 segundos resulta em 30 segundos no total

    $sessao = uniqid();
       
    global $woocommerce;
    $logger = wc_get_logger();
    
    $order = wc_get_order( $order_id );

    // Obtenha todas as configurações do gateway
    $gateway_settings = get_option('woocommerce_primepaggateway_settings');

    $gate_title = $gateway_settings['title'];
    $gate_description = $gateway_settings['description'];
    $gate_enabled = $gateway_settings['enabled'];
    $gate_client_id = $gateway_settings['client_id'];
    $gate_client_secret = $gateway_settings['client_secret'];
    
    $gate_url_de_conexao_api_producao = $gateway_settings['url_de_conexao_api'];

    $primepag_url = $gate_url_de_conexao_api_producao;
    $gate_client_id = $gateway_settings['client_id'];
    $gate_client_secret = $gateway_settings['client_secret'];
    

    for ($i = 0; $i < $tentativas; $i++) {
        
        $token = primepag_token($primepag_url,$gate_client_id,$gate_client_secret);
    
        $debug_auth = array("URL" => $primepag_url,
                            "CLIENT_ID" => $gate_client_id,
                            "CLIENT_SECRET" => $gate_client_secret);
    
        
        $logger->info( "primepag_client_token: ".$token, array( 'source' => 'debug-primepag-consultas' ) );
    
        $curl = curl_init();
    
        curl_setopt_array($curl, array(
        CURLOPT_URL => $primepag_url . '/v1/pix/qrcodes/' . $codigo_ref,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_HTTPHEADER => array(
            'Authorization: Bearer ' . $token
        ),
        ));
    
        $response = curl_exec($curl);
    
        curl_close($curl);
        
        $response = json_decode($response, true);
    
        // PEDIDO TEVE A CONFIRMAÇÃO DO PAGAMENTO
        if($response["qrcode"]["status"]=="paid"):
    
            $order->update_status( 'wc-processing' );
            wc_reduce_stock_levels( $order->get_id() );
            $order->add_order_note( "PIX PRIMEPAG CONFIRMADO!" );
    
        endif;

        // Aguardar 10 segundos antes da próxima tentativa
        sleep(25);
    }
}


?>