<?php 
/**
*  ------------------------------------------------------------------------------------------------
*
*
*   TOKEN
*
*
*  ------------------------------------------------------------------------------------------------
*/
function primepag_token($primepag_url,$primepag_client_id,$primepag_client_secret){

        $curl = curl_init();

        //$credentials = base64_encode($primepag_client_id . ':' . $primepag_client_secret);

        curl_setopt_array($curl, array(
            CURLOPT_URL => $primepag_url . 'auth/v1/token',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => 'client_key='.$primepag_client_id.'&client_secret='.$primepag_client_secret,
            CURLOPT_HTTPHEADER => array(
              'Content-Type: application/x-www-form-urlencoded'
            ),
        ));

        $response_t = curl_exec($curl);

        $response = json_decode($response_t, true);

        $logger = wc_get_logger();
        $logger->info( "\TOKEN RESPONSE: ", array( 'source' => 'debug-paggue' ) );
        $logger->info( $response_t, array( 'source' => 'debug-paggue' ) );

        curl_close($curl);

        if($response['access_token']) return $response['access_token'] . "###" . $response['user']['companies'][0]['id'];

        return false;

}

/**
*  ------------------------------------------------------------------------------------------------
*
*
*   PIX
*
*
*  ------------------------------------------------------------------------------------------------
*/
function primepag_pix($pre_token,$primepag_url,$order_id){

    $ex = explode("###",$pre_token);
    $token = $ex[0];
    $companie = $ex[1];

    global $woocommerce;
	$order = wc_get_order( $order_id );

    $order_data = $order->get_data();

	$cpf = str_replace(".","",get_post_meta($order->get_id(),'_billing_cpf',true));
	$cpf = str_replace("-","",$cpf);
	$cpf = str_replace(" ","",$cpf);
    $cpf = str_replace("/","",$cpf);
    $cpf = str_replace("-","",$cpf);

    if($cpf=="" || $cpf==" "):
        $cpf = "68965480027";
    endif;


    $nome = $order_data['billing']['first_name'] . ' ' . $order_data['billing']['last_name'];

    if($nome=="" || $nome==" "):
        $nome = "Cliente ".get_option("blogname");
    endif;

    $total_pedido       = $order_data['total'];
    $total_pedido_cents = (int)($total_pedido * 100);

    $payload = '{
        "payer_name": "'.$nome.'",
        "amount": '.$total_pedido_cents.',
        "external_id": "'.$order_id.'",
        "description": "Pagamento pedido '.$order_id.'",
        "meta": {
            "extra_data": "Origem: '.get_option('home').'"
        }
    }';
    
    $curl = curl_init();

    
    curl_setopt_array($curl, array(
        CURLOPT_URL => $primepag_url . 'cashin/api/billing_order',
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'POST',
        CURLOPT_POSTFIELDS => $payload,
        CURLOPT_HTTPHEADER => array(
        'Signature: '.hash('sha256', $token),
        'X-Company-ID: '.$companie,
        'Content-Type: application/json',
        'Authorization: Bearer '.$token
        ),
    ));

    $response = curl_exec($curl);

    curl_close($curl);

    $logger = wc_get_logger();
    $logger->info( "\nPAYLOAD: ".$payload, array( 'source' => 'debug-paggue' ) );
    $logger->info( "\nTOKEN HASH: ".hash('sha256', $token), array( 'source' => 'debug-paggue' ) );
    $logger->info( "\nCOMPANIE: ".$companie, array( 'source' => 'debug-paggue' ) );
    $logger->info( "\nPRE TOKEN: ".$pre_token, array( 'source' => 'debug-paggue' ) );
    
    $logger->info( "\nPAYLOAD RESPONSE: ", array( 'source' => 'debug-paggue' ) );
    $logger->info( $response, array( 'source' => 'debug-paggue' ) );


    // Verifique se houve erro no cURL
    if (curl_errno($curl)) {
        
        $error_msg = curl_error($curl);
        $error_no = curl_errno($curl);
        
        
        $logger->info( "\n\ERRO CURL: ".$ambiente, array( 'source' => 'debug-paggue' ) );

    }

    $response = json_decode($response, true);

    if($response['payment']):

        // VERIFICAR SE O PAGAMENTO FOI FEITO
        //if (!wp_next_scheduled('executar_consultar_transacao_primepag')) {
        //    wp_schedule_single_event(time(), 'executar_consultar_transacao_primepag', array($status_pagamento["reference_code"], $id_pedido));
        //}

        return array("reference_code" => $response['hash'], 
                     "content"        => $response['payment'], 
                     "image_qrcode"   => pix_code_to_qrcode_avulso_paggue($response['payment']));

    else:

        return $response;

    endif;


}





?>